// 003 u_c_ado_net_bdp_helpers
// 04 oct 2006

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_ado_net_bdp_helpers;
  interface
    uses System.Data
        , Borland.Data.Provider
        , u_c_dot_net_basic_object;

    type c_ado_net_helpers= Class(c_basic_object)
                              m_c_bdp_connection_ref: bdpConnection;

                              constructor create_ado_net_helpers(p_name: String;
                                  p_c_bdp_connection_ref: bdpConnection);

                              procedure execute_non_query(p_do_execute: Boolean; p_request: System.String);
                              procedure list_data_table(p_request: System.String; p_column_count: Integer);
                              procedure display_data_set_table_names(p_c_data_set: DataSet);
                              procedure display_data_table_column_names(p_c_data_table: DataTable);
                            end; // c_ado_net_helpers

    function f_data_row_action_name(p_data_row_action: DataRowAction): System.String;

  implementation
    uses u_dot_net_types_constants, u_c_dot_net_display
      , u_dot_net_strings
      ;

    function f_data_row_action_name(p_data_row_action: DataRowAction): System.String;
      begin
        Result:= Enum.GetName(TypeOf(DataRowAction), p_data_row_action);
      end; // f_data_row_action_name

    // -- c_ado_net_helpers

    constructor c_ado_net_helpers.create_ado_net_helpers(p_name: String;
        p_c_bdp_connection_ref: bdpConnection);
      begin
        Inherited create_basic_object(p_name);

        m_c_bdp_connection_ref:= p_c_bdp_connection_ref;
      end; // create_ado_net_helpers

    procedure c_ado_net_helpers.execute_non_query(p_do_execute: Boolean; p_request: System.String);
        // -- connection IS open
      var l_c_command: bdpCommand;
          l_count: Integer;
      begin
        display_line;
        display('> execute_non_query');
        display(p_request);

        if p_do_execute
          then begin
              l_c_command:= bdpCommand.Create(p_request, m_c_bdp_connection_ref);
              l_count:= l_c_command.ExecuteNonQuery();
            end;

        display('< count '+ l_count.ToString);
      end; // execute_non_query

    procedure c_ado_net_helpers.list_data_table(p_request: System.String; p_column_count: Integer);
        // -- connection IS closed
      var l_c_command: bdpCommand;
          l_c_reader: iDataReader;
          l_row_index: Integer;
          l_column_index: Integer;
          l_display: String;
      begin
        display_line;
        display('> list_data_table '+ p_request);
        l_c_command:= m_c_bdp_connection_ref.CreateCommand();
        l_c_command.CommandText:= p_request;

        m_c_bdp_connection_ref.Open();
        l_c_reader:= l_c_command.ExecuteReader();

        l_row_index:= 0;
        while l_c_reader.Read() do
        begin
          l_display:= '';
          for l_column_index:= 0 to p_column_count- 1 do
            l_display:= l_display+ ' '+ l_c_reader.GetValue(l_column_index).ToString; // + ' '+ l_c_reader.GetValue(1).ToString;
          display(l_row_index.ToString+ ':'+ l_display);
          Inc(l_row_index);
        end; // while
        m_c_bdp_connection_ref.Close();
        display('< list_data_table');
      end; // list_data_table

    procedure c_ado_net_helpers.display_data_set_table_names(p_c_data_set: DataSet);
      var l_table_index: Integer;
          l_c_table: DataTable;
      begin
        for l_table_index:= 0 to p_c_data_set.Tables.Count- 1 do
          display(p_c_data_set.Tables[l_table_index].TableName);
      end; // display_dataset_table_names

    procedure c_ado_net_helpers.display_data_table_column_names(p_c_data_table: DataTable);
      var l_column_index: Integer;
      begin
        for l_column_index:= 0 to p_c_data_table.Columns.Count- 1 do
          display(p_c_data_table.Columns[l_column_index].ColumnName);
      end; // display_data_table_column_names

end.
